Session::Jingle Class Reference

`#include <jinglesession.h>`

Inheritance diagram for Session::Jingle:
[legend]

## Public Member Functions

| Jingle (const Tag *tag=0)
virtual | ~Jingle ()
const std::string & | sid () const
const JID & | initiator () const
const JID & | responder () const
Action | action () const
void | addPlugin (const Plugin *plugin)
const PluginList & | plugins () const
Tag * | embeddedTag () const
virtual const std::string & | filterString () const
virtual StanzaExtension * | newInstance (const Tag *tag) const
virtual Tag * | tag () const
virtual StanzaExtension * | clone () const
Public Member Functions inherited from StanzaExtension
| StanzaExtension (int type)
virtual | ~StanzaExtension ()
virtual Stanza * | embeddedStanza () const
int | extensionType () const

## Detailed Description

This is an abstraction of Jingle's (XEP-0166) <jingle> element as a StanzaExtension.

XEP Version: 1.1

Author
  Jakob Schröter js@ca.nosp@m.maya.nosp@m..net

Since
  1.0.5

Definition at line 198 of file jinglesession.h.

## Constructor & Destructor Documentation

## Jingle()

Jingle | ( | const Tag * | tag = 0 | ) |

Constructs a new object from the given Tag.

Parameters

  tag | The Tag to parse.

Definition at line 153 of file jinglesession.cpp.

## ~Jingle()

~Jingle | ( |  | ) |

virtual

Virtual Destructor.

Definition at line 177 of file jinglesession.cpp.

## Member Function Documentation

## action()

Action action | ( |  | ) | const

inline

Returns this Jingle's action.

Returns
  The action.

Definition at line 237 of file jinglesession.h.

## addPlugin()

void addPlugin | ( | const Plugin * | plugin | ) |

inline

Adds a Plugin as child.

Parameters

  plugin | A plugin to be embedded. Will be owned by this instance and deleted in the destructor.

Definition at line 243 of file jinglesession.h.

## clone()

StanzaExtension * clone | ( |  | ) | const

virtual

Returns an identical copy of the current StanzaExtension.

Returns
  An identical copy of the current StanzaExtension.

Implements StanzaExtension.

Definition at line 212 of file jinglesession.cpp.

## embeddedTag()

Tag * embeddedTag | ( |  | ) | const

inline virtual

Returns the tag to build plugins from.

Returns
  The tag to build plugins from.

Reimplemented from StanzaExtension.

Definition at line 255 of file jinglesession.h.

## filterString()

const std::string & filterString | ( |  | ) | const

virtual

Returns an XPath expression that describes a path to child elements of a stanza that an extension handles.

Returns
  The extension's filter string.

Implements StanzaExtension.

Definition at line 182 of file jinglesession.cpp.

## initiator()

const JID & initiator | ( |  | ) | const

inline

Returns the 'session initiator'. This will usually be empty for any action other than 'session-initiate'.

Returns
  The 'session initiator'.

Definition at line 225 of file jinglesession.h.

## newInstance()

virtual StanzaExtension * newInstance | ( | const Tag * | tag | ) | const

inline virtual

Returns a new Instance of the derived type. Usually, for a derived class FooExtension, the implementation of this function looks like:

StanzaExtension* FooExtension::newInstance( const Tag* tag ) const
{
return new FooExtension( tag );
}
gloox::Jingle::Session::Jingle::tag
virtual Tag * tag() const
Definition jinglesession.cpp:188
gloox::StanzaExtension::StanzaExtension
StanzaExtension(int type)
Definition stanzaextension.h:211
gloox::Tag
This is an abstraction of an XML element.
Definition tag.h:47

Returns
  The derived extension's new instance.

Implements StanzaExtension.

Definition at line 261 of file jinglesession.h.

## plugins()

const PluginList & plugins | ( |  | ) | const

inline

Returns a reference to a list of embedded plugins.

Returns
  A reference to a list of embedded plugins.

Definition at line 249 of file jinglesession.h.

## responder()

const JID & responder | ( |  | ) | const

inline

Returns the 'session responder'. This will usually be empty for any action other than 'session-accept'.

Returns
  The 'session responder'.

Definition at line 231 of file jinglesession.h.

## sid()

const std::string & sid | ( |  | ) | const

inline

Returns the session ID.

Returns
  The session ID.

Definition at line 219 of file jinglesession.h.

## tag()

Tag * tag | ( |  | ) | const

virtual

Returns a Tag representation of the extension.

Returns
  A Tag representation of the extension.

Implements StanzaExtension.

Definition at line 188 of file jinglesession.cpp.

The documentation for this class was generated from the following files:

- jinglesession.h
- jinglesession.cpp